"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateAsDataItemDelegateV2 = exports.getUpdateAsDataItemDelegateV2InstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const hooked_1 = require("../../hooked");
const accounts_1 = require("../accounts");
const shared_1 = require("../shared");
const types_1 = require("../types");
function getUpdateAsDataItemDelegateV2InstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['updateAsDataItemDelegateV2Discriminator', s.u8()],
        [
            'data',
            s.option(s.struct([
                ['name', s.string()],
                ['symbol', s.string()],
                ['uri', s.string()],
                ['sellerFeeBasisPoints', s.u16()],
                ['creators', s.option(s.array((0, types_1.getCreatorSerializer)(context)))],
            ])),
        ],
        [
            'authorizationData',
            s.option((0, types_1.getAuthorizationDataSerializer)(context)),
        ],
    ], { description: 'UpdateAsDataItemDelegateV2InstructionData' }), (value) => ({
        ...value,
        discriminator: 50,
        updateAsDataItemDelegateV2Discriminator: 6,
        data: value.data ?? (0, umi_1.none)(),
        authorizationData: value.authorizationData ?? (0, umi_1.none)(),
    }));
}
exports.getUpdateAsDataItemDelegateV2InstructionDataSerializer = getUpdateAsDataItemDelegateV2InstructionDataSerializer;
// Instruction.
function updateAsDataItemDelegateV2(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = {
        ...context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'),
        isWritable: false,
    };
    // Resolved inputs.
    const resolvingAccounts = {};
    const resolvingArgs = {};
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authority', input.authority ?? context.identity);
    (0, shared_1.addObjectProperty)(resolvingArgs, 'updateAuthority', input.updateAuthority ?? context.identity.publicKey);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'delegateRecord', input.delegateRecord ??
        (0, accounts_1.findMetadataDelegateRecordPda)(context, {
            mint: (0, umi_1.publicKey)(input.mint),
            delegateRole: types_1.MetadataDelegateRole.DataItem,
            updateAuthority: resolvingArgs.updateAuthority,
            delegate: (0, umi_1.publicKey)(resolvingAccounts.authority),
        }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'token', input.token ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'metadata', input.metadata ?? (0, accounts_1.findMetadataPda)(context, { mint: (0, umi_1.publicKey)(input.mint) }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'edition', input.edition ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'payer', input.payer ?? context.payer);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'systemProgram', input.systemProgram ?? {
        ...context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'sysvarInstructions', input.sysvarInstructions ??
        (0, umi_1.publicKey)('Sysvar1nstructions1111111111111111111111111'));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authorizationRules', input.authorizationRules ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authorizationRulesProgram', input.authorizationRulesProgram ??
        (0, hooked_1.resolveAuthorizationRulesProgram)(context, { ...input, ...resolvingAccounts }, { ...input, ...resolvingArgs }, programId));
    const resolvedAccounts = { ...input, ...resolvingAccounts };
    const resolvedArgs = { ...input, ...resolvingArgs };
    // Authority.
    signers.push(resolvedAccounts.authority);
    keys.push({
        pubkey: resolvedAccounts.authority.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authority, false),
    });
    // Delegate Record.
    keys.push({
        pubkey: resolvedAccounts.delegateRecord,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.delegateRecord, false),
    });
    // Token.
    keys.push({
        pubkey: resolvedAccounts.token,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.token, false),
    });
    // Mint.
    keys.push({
        pubkey: resolvedAccounts.mint,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.mint, false),
    });
    // Metadata.
    keys.push({
        pubkey: resolvedAccounts.metadata,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.metadata, true),
    });
    // Edition.
    keys.push({
        pubkey: resolvedAccounts.edition,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.edition, false),
    });
    // Payer.
    signers.push(resolvedAccounts.payer);
    keys.push({
        pubkey: resolvedAccounts.payer.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.payer, true),
    });
    // System Program.
    keys.push({
        pubkey: resolvedAccounts.systemProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.systemProgram, false),
    });
    // Sysvar Instructions.
    keys.push({
        pubkey: resolvedAccounts.sysvarInstructions,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.sysvarInstructions, false),
    });
    // Authorization Rules Program.
    keys.push({
        pubkey: resolvedAccounts.authorizationRulesProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authorizationRulesProgram, false),
    });
    // Authorization Rules.
    keys.push({
        pubkey: resolvedAccounts.authorizationRules,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authorizationRules, false),
    });
    // Data.
    const data = getUpdateAsDataItemDelegateV2InstructionDataSerializer(context).serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.updateAsDataItemDelegateV2 = updateAsDataItemDelegateV2;
//# sourceMappingURL=updateAsDataItemDelegateV2.js.map